#ifndef __MessageFormats__
#define __MessageFormats__
enum RequestType
{
    GET,
    PUT,
    DELETE,
    INVALIDATE
};
enum ResponseStatus
{
    SUCCESS,
    FAILURE
};

struct __attribute__ ((__packed__)) SalRequestHeader
{
    uint32_t id;
    enum RequestType type;
    uint32_t keySize;
    uint32_t valueSize;
};

struct __attribute__ ((__packed__)) SalResponseHeader
{
    uint32_t  id;
    enum ResponseStatus status;
    /*
    * Note value will be present only in case of response status is success
    */
    uint32_t valueSize;
};

struct __attribute__ ((__packed__)) InvRequestHeader
{
    uint32_t  id;
    enum RequestType type;
    uint32_t keySize;    
};


struct __attribute__ ((__packed__)) InvResponseHeader
{
    uint32_t  id;
    enum ResponseStatus status; 
};
static uint32_t SalRequestHeaderSize = sizeof(SalRequestHeader);
static uint32_t SalResponseHeaderSize = sizeof(SalResponseHeader);
static uint32_t InvRequestHeaderSize = sizeof(InvRequestHeader);
static uint32_t InvResponseHeaderSize = sizeof(InvResponseHeader);

#endif