#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <errno.h>
#include <unordered_map>

#ifndef __RDMACLIENTENDPOINTGROUP__
#define __RDMACLIENTENDPOINTGROUP__

#include "RdmaEndpointGroup.hpp"
#include "RdmaCqProcessor.hpp"
#include "RdmaCmProcessor.hpp"
#include "RdmaClientEndpoint.hpp"

class RdmaClientEndpointGroup : public RdmaEndpointGroup
{
    RdmaCmProcessor *_cmProcessor = NULL;
    RdmaCqProcessor *_cqProcessor = NULL;
    //struct rdma_cm_id *_cm_id;

    int _sendQueueSize;
    int _recvQueueSize;
    int _compQueueSize;
    int _sendMsgSize;
    int _recvMsgSize;
    int _timeoutMs;
    int _maxInLine;

public:
    RdmaClientEndpointGroup(int sendQueueSize, int recvQueueSize, int compQueueSize, int sendMsgSize,
                            int recvMsgSize,int maxInLine, int timeout);
    void processCmEvent(struct rdma_cm_event *event);
    struct ibv_cq *createCq(struct rdma_cm_id *id);
    RdmaClientEndpoint *createEndpoint();

};
#endif