#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <thread>
#include <iostream>

#ifndef __RDMACMPROCESSOR__
#define __RDMACMPROCESSOR__

#include "RdmaEndpointGroup.hpp"
#include <unordered_map>

class RdmaCmProcessor
{

    struct rdma_event_channel *_eventChannel;
    std::thread *_cmEventThread;
    RdmaEndpointGroup *_endpointGroup;
    bool _stop;


public:
    RdmaCmProcessor(RdmaEndpointGroup *group);
    struct rdma_event_channel *getEventChannel();
    struct rdma_cm_id *createId();
    void close();
    void start();
    void processCmEvent();
};
#endif