#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <iostream>
#include <thread>
#include <unordered_map>

#ifndef __RDMACQPROCESSOR__
#define __RDMACQPROCESSOR__

#include "RdmaClientEndpoint.hpp"

class RdmaCqProcessor
{
public:
	struct ibv_comp_channel *_compChannel;
	struct ibv_cq *_completionQueue;
	std::thread *_compQueueThread;
	std::unordered_map<uint32_t, RdmaClientEndpoint *> *_qpEndpointMap{NULL};

	RdmaCqProcessor(ibv_context *verbs, int compQueueSize);
	struct ibv_cq *getCq();
	void start();
	void processCQEvents();
	void dispatchCqEvents(ibv_wc *wc_array, int size);
	void close();
	void registerEp(uint64_t qpum, RdmaClientEndpoint* ep);
};

#endif

// https://www.rdmamojo.com/2013/03/09/ibv_get_cq_event/
// https://man7.org/linux/man-pages/man3/ibv_poll_cq.3.html
// https://man7.org/linux/man-pages/man3/ibv_get_cq_event.3.html