#include <stdio.h>
#include "Hello.h" // generated by javah
#include "RdmaClientEndpoint.hpp"

/*
bool rocksdb_put_helper(JNIEnv* env, ROCKSDB_NAMESPACE::DB* db,
                        const ROCKSDB_NAMESPACE::WriteOptions& write_options,
                        ROCKSDB_NAMESPACE::ColumnFamilyHandle* cf_handle,
                        jbyteArray jkey, jint jkey_off, jint jkey_len,
                        jbyteArray jval, jint jval_off, jint jval_len) {
  jbyte* key = new jbyte[jkey_len];
  env->GetByteArrayRegion(jkey, jkey_off, jkey_len, key);
  if (env->ExceptionCheck()) {
    // exception thrown: ArrayIndexOutOfBoundsException
    delete[] key;
    return false;
  }

  jbyte* value = new jbyte[jval_len];
  env->GetByteArrayRegion(jval, jval_off, jval_len, value);
  if (env->ExceptionCheck()) {
    // exception thrown: ArrayIndexOutOfBoundsException
    delete[] value;
    delete[] key;
    return false;
  }

*/
JNIEXPORT jbyteArray JNICALL Java_Hello_get(JNIEnv *jenv, jobject jobj, jbyteArray jkey)
{
	int keyLen = jenv->GetArrayLength(jkey);
	char* key = new char[keyLen];
	jenv->GetByteArrayRegion(jkey,0,keyLen,reinterpret_cast<jbyte*>( key));
	if(jenv->ExceptionCheck())
	{
		std::cout<<"exception occurs get"<<std::endl;
		delete[] key;
	}
	std::cout<<"get "<<key<< "len "<<keyLen<<std::endl;
	
	int valLen;
	valLen = 6;
	jbyteArray jvalue = jenv->NewByteArray(valLen);
	jenv->SetByteArrayRegion(jvalue,0,5,reinterpret_cast<const jbyte*>("paras"));
	delete[] key;
	return jvalue;
}

JNIEXPORT jint JNICALL Java_Hello_put(JNIEnv *jenv, jobject jobj, jbyteArray jkey, jbyteArray jval)
{
	int keyLen = jenv->GetArrayLength(jkey);
	char* key = new char[keyLen];
	jenv->GetByteArrayRegion(jkey,0,keyLen,reinterpret_cast<jbyte*>(key));
	
	int valLen = jenv->GetArrayLength(jval);
	char* val = new char[valLen];
	jenv->GetByteArrayRegion(jval,0,valLen,reinterpret_cast<jbyte*>(val));

	if(jenv->ExceptionCheck())
	{
		std::cout<<"put exception occur"<<std::endl;
		delete[] key;
		delete[] val;
	}
	std::cout<<"put "<<key<< " len "<<keyLen<<" "<<val<<" len "<<valLen<<std::endl;
	delete[] key;
	delete[] val;
	return 1;
}

JNIEXPORT jint JNICALL Java_Hello_delete(JNIEnv *jenv, jobject jobj, jbyteArray jkey)
{
	int keyLen = jenv->GetArrayLength(jkey);
	char* key = new char[keyLen];
	jenv->GetByteArrayRegion(jkey,0,keyLen,reinterpret_cast<jbyte*>(key));
	if(jenv->ExceptionCheck())
	{
		std::cout<<"exception occurs delete"<<std::endl;
		delete[] key;
	}
	std::cout<<"delete "<<key<< "len "<<keyLen<<std::endl;
	delete[] key;
	return 1;
}