#include "RdmaCmProcessor.hpp"
#include <iostream>

RdmaCmProcessor::RdmaCmProcessor(RdmaEndpointGroup *group)
    : _endpointGroup(group)
{
    std::cout << "CMProcessor : Step 1 creating event channel" << std::endl;
    _eventChannel = rdma_create_event_channel();
    _stop = false;
    if (_eventChannel == NULL)
    {
        std::cout << "CMProcesor : error creating event channel";
    }
}

struct rdma_event_channel *RdmaCmProcessor::getEventChannel()
{
    return _eventChannel;
}
struct rdma_cm_id *RdmaCmProcessor::createId()
{
    struct rdma_cm_id *id = NULL;
    int ret = rdma_create_id(_eventChannel, &id, NULL, RDMA_PS_TCP);
    if (ret == -1)
        std::cout << "CMProcesor : rdma_create_id failed" << std::endl;
    return id;
}

void RdmaCmProcessor::start()
{
    _cmEventThread = new std::thread(&RdmaCmProcessor::processCmEvent, this);
    pthread_setname_np(_cmEventThread->native_handle(),"CMProcessor");
}

void RdmaCmProcessor::processCmEvent()
{
    int ret;
    struct rdma_cm_event *event;
    std::cout << "CMProcessor : starting cm processing thread" << std::endl;
    while (!_stop)
    {
        ret = rdma_get_cm_event(_eventChannel, &event);
        if (ret)
        {
            std::cout << "CMProcesor : rdma_get_cm_event failed" << std::endl;
            continue;
        }
        _endpointGroup->processCmEvent(event);
        ret = rdma_ack_cm_event(event);
        if (ret)
        {
            std::cout << "CMProcesor : rdma_ack_cm_event failed";
        }
    }
}

void RdmaCmProcessor::close()
{
    _stop = true;
    _cmEventThread->join();
    rdma_destroy_event_channel(_eventChannel);
}